#!/usr/bin/env python

#############################
#GNU GPL license
#author: benoit
#mail: luxeisdust@gmail.com
#############################




import pygtk
import sys
import os
import subprocess

import gtk
import gnomeapplet
import gnome.ui
import gobject

pygtk.require('2.0')

import commands



def execute_command(cmd,dryrun=False,tries=1,output=sys.stdout):
	hadsts = 0
	sts = None
	ret = None
	if dryrun:
		output.write( cmd  + " : FAKE\n")
	else:
		t = 0
		while t < tries:
			p = subprocess.Popen(cmd, shell=True, stdout = subprocess.PIPE)
			ret = p.stdout.read()
			sts = os.waitpid(p.pid, 0)[1]
			if sts != 0:
				output.write( cmd  + " : \033[1;31mFail\033[0m\n")
			else:
				output.write( cmd  + " : \033[1;32mOk\033[0m\n")
				break
			t = t+1
		if t == tries:
			hadsts += 1
	return (sts,ret)


class TimeoutFunctionException(Exception): 
	"""Exception to raise on a timeout""" 
	pass 

class TimeoutFunction: 

	def __init__(self, function, timeout): 
		self.timeout = timeout 
		self.function = function 

	def handle_timeout(self, signum, frame): 
		raise TimeoutFunctionException()

	def __call__(self, *args): 
		old = signal.signal(signal.SIGALRM, self.handle_timeout) 
		signal.alarm(self.timeout) 
		try: 
		    result = self.function(*args)
		finally: 
		    signal.signal(signal.SIGALRM, old)
		signal.alarm(0)
		return result 


class cpu_freq_applet: 
	str_freq_cpu = "0 GHz"
	freq_cpu = 0.0
	def cleanup(self,event):
		del self.applet
	def read_cpu_freq(self):
		p = os.path.abspath(os.path.dirname(sys.argv[0]))
#		p = p[:p.rfind("/")]

		(sts,ret) = execute_command( p + "/turbostat")
		self.str_freq_cpu = ret.strip()

	def update(self,event):
		self.read_cpu_freq()

		self.label.set_text(self.str_freq_cpu +" GHz")
		print self.str_freq_cpu
		gtk.main_iteration()
		return 1

	def __init__(self, applet, iid): 
		
		gnome.init("cpu_freq_applet", "1.0")
		self.applet = applet

		self.hbox = gtk.HBox()
		applet.add(self.hbox)
		

		self.label = gtk.Label(self.str_freq_cpu)
		self.hbox.add(self.label)
		self.update(None)
		gobject.timeout_add(1000,self.update, self)
		applet.connect("destroy",self.cleanup)
		applet.show_all()
		applet.connect("change-background", self.onChangeBackground)   

	def onChangeBackground(self, applet, type, color, pixmap):
		applet.set_style(None)
		rc_style = gtk.RcStyle()
		applet.modify_style(rc_style)
		if (type == gnomeapplet.COLOR_BACKGROUND):
			applet.modify_bg(gtk.STATE_NORMAL, color)
		elif (type == gnomeapplet.PIXMAP_BACKGROUND):
			style = applet.style
			style.bg_pixmap[gtk.STATE_NORMAL] = pixmap
			self.applet.set_style(style)  

def cpu_freq_applet_factory(applet,iid):

	app = cpu_freq_applet(applet,iid)
	return gtk.TRUE
	
if len(sys.argv) == 2 and sys.argv[1] == "run-in-window":
	main_window = gtk.Window(gtk.WINDOW_TOPLEVEL)
	main_window.set_title("cpu_freq_applet")
	main_window.connect("destroy", gtk.main_quit) 
	app = gnomeapplet.Applet()
	cpu_freq_applet_factory(app, None)
	app.reparent(main_window)
	main_window.show_all()
	gtk.main()
	sys.exit()
	
if __name__ == '__main__':
	print "launch"
	gnomeapplet.bonobo_factory("OAFIID:GNOME_cpu_freq_applet_Factory", gnomeapplet.Applet.__gtype__, "cpu_freq_applet", "0", cpu_freq_applet_factory) 





